/*           Foolish Editor v0.01
 *  Designed By Cloud Wu (July 17, 1998)
 *  I wrote this program to tell you how to create a editor.
 *  It's short in function, (I cost 140 min on programming it).
 *  don't use it for really editting something, even it can do it.
 *
 *  This program is compiled by djgpp,
 *  gcc -O3 -s -o fed.exe fed.c
 *  In other environment, _setcursortype() ,maybe, in other name
 *
 *  Welcome to http://www.nease.net/~cloudwu
 *  Any comment to cloudwu@263.net
 */

#include <stdio.h>
#include <conio.h>
#include <string.h>

#define TEXTCOLOR YELLOW
#define TEXTBACK BLUE
#define STATCOLOR BLACK
#define STATBACK CYAN
#define HIGHT 24
#define WIDTH 80
#define MAXLEN 32768
#define MAXLINES (MAXLEN/3)
#define ESC 27
#define UP 0x148
#define DOWN 0x150
#define PGUP 0x149
#define PGDOWN 0x151
#define LEFT 0x14b
#define RIGHT 0x14d
#define ENTER 0x0d
#define HOME 0x147
#define END 0x14f
#define DEL 0x153
#define INS 0x152
#define F2 0x13c
#define CTRLY 0x19
#define CTRLP 0x10
#define CTRLD 0x4
#define CTRLHOME 0x177
#define CTRLEND 0x175
#define CTRLPGUP 0x184
#define CTRLPGDOWN 0x176
#define ALTLEFT 0x19b
#define ALTRIGHT 0x19d
#define ALTUP 0x198
#define ALTDOWN 0x1a0
#define ALTENTER 0x11c
#define ALTDEL 0x1a3
#define ALTBAK 0x10e
#define BACK 0x8
#define CTRLENTER 0xa
#define CTRLINS 0x192
#define CTRLDEL 0x193
#define F1 0x13b

int size;
int curline;
int linex;
int x;
int topline;
int pshowtext;
int pshowline;
int lines;
int insert;
char buf[MAXLEN];
int line[MAXLINES];

int init(char *fname);
void showtext(void);
void showstatbar(void);
void copyright();
void inschar(char);
void countline(void);
void inschar(char);
void delchar(void);
void savefile(char *);

void countline(void)
{
 int i,s=1;
 for (i=0;i<size;i++)
    if (buf[i]==0) {
      line[s++]=i+1;
      }
}

void showline(void)
{
 _setcursortype(_NOCURSOR);
 gotoxy(1,curline-topline+1);
 if (strlen(buf+line[curline])<=linex) clreol();
 else cprintf("%-*.*s",WIDTH,WIDTH,buf+line[curline]+linex);

}

void inschar(char a)
{
 int i,l;
 l=strlen(buf+line[curline]);
 i=x-l+1;
 if (size+i>MAXLEN) return;
 if (i<1) i=1;
 if (a==0 && i>1) x=l;
 if (i>1 && a!=0) {
   memmove(buf+line[curline]+x+1,buf+line[curline]+l,size-(line[curline]+l));
   memset(buf+line[curline]+l,' ',i-1);
   }
 else memmove(buf+line[curline]+x+1,buf+line[curline]+x,size-(line[curline]+x));
 size+=i;
 buf[line[curline]+x]=a;
 ++x;
 if (x-linex>=WIDTH) pshowtext=1,linex++;
 else pshowline=1;
 if (a==0) {
   if (++curline-topline>=HIGHT) topline++;
   x=linex=0;
   pshowtext=1;
   lines++;
   }
 countline();
 return;
}

void delchar(void)
{
 int i,l;
 if (size<=0) return;
 l=strlen(buf+line[curline]);
 i=x-l;
 if (i>=0 && !insert) return;
 if (size+i>MAXLEN) return;
 if (i<0) i=0;
 else pshowtext=1,--lines;
 if (i>0) {
   memmove(buf+line[curline]+x,buf+line[curline]+l+1,size-(line[curline]+l+1));
   memset(buf+line[curline]+l,' ',i);
   }
 else memmove(buf+line[curline]+x,buf+line[curline]+x+1,size-(line[curline]+x));
 size+=i-1;
 pshowline=1;
 countline();
 return;
}

int init(char *fname)
{
 FILE *f;
 int i;
 if ((f=fopen(fname,"r"))==NULL) {
    size=0;
    lines=0;
    return 0;
    }
 size=fread(buf,1,MAXLEN,f);
 line[lines=0]=0;
 for (i=0;i<size;i++)
    if (buf[i]=='\n') {
      buf[i]=0;
      line[++lines]=i+1;
      }
 textbackground(STATBACK);
 clrscr();
 window(1,1,WIDTH,HIGHT);
 textbackground(TEXTBACK);
 clrscr();
 window(1,1,WIDTH,HIGHT+1);
 textcolor(TEXTCOLOR);
 curline=topline=x=linex=0;
 insert=1;
 showtext();
 showstatbar();
 gotoxy(x-linex+1,curline-topline+1);
 fclose(f);
 return 0;
}

void savefile(char *fname)
{
 FILE *f;
 int i;
 if ((f=fopen(fname,"w"))==NULL) return;
 for (i=0;i<lines;i++)
    fprintf(f,"%s\n",buf+line[i]);
 fclose(f);
}

void showstatbar()
{
 textbackground(STATBACK);
 textcolor(STATCOLOR);
 gotoxy(1,HIGHT+1);
 cprintf("%4d/%4d",curline+1,x+1);
 textbackground(TEXTBACK);
 textcolor(TEXTCOLOR);
 gotoxy(x-linex+1,curline-topline+1);
}

void showtext()
{
 int i,hight=HIGHT;
 if (hight+topline-1>lines) hight=lines-topline+1;
 _setcursortype(_NOCURSOR);
 for (i=0;i<hight;i++)
 {
    gotoxy(1,i+1);
    if (strlen(buf+line[i+topline])<=linex) clreol();
    else cprintf("%-*.*s",WIDTH,WIDTH,buf+line[i+topline]+linex);
 }
 for (;i<HIGHT;i++)
    {
    gotoxy(1,i+1);
    clreol();
    }
}

void copyright()
{
 clrscr();
 puts("\tFoolish Editor v0.01\nDesigned By Cloud Wu (July 17, 1998)\n");
 puts("It's foolish, isn't it? Mmmm, All right unreserved ;-)");
 puts("I wrote this program to tell you how to create a editor.\nIt's short in function, (I cost 140 min on programming it).\ndon't use it for really editting something, even it can do it.");
 puts("Notice:\tThe source must be put with EXE file.\nIf you don't see the source code, please tell me where you get this program.");
 puts("\nWelcome to http://www.nease.net/~cloudwu");
 puts("Any comment to cloudwu@263.net");
 puts("\nUsage:\tFED\t filename");
 exit(1);
}

int main(int agc,char *agv[])
{
 int key;
 if (agc<2) copyright();
 if (init(agv[1])) return 2;
 init(agv[1]);
 for (;;)
    {
     if (insert) _setcursortype(_NORMALCURSOR);
     else _setcursortype(_SOLIDCURSOR);
     pshowtext=pshowline=0;
     key=getch();
     if (key==0) key=0x100+getch();
     switch(key) {
       case UP: if (--curline<0) curline=0;
            if (curline<topline) topline--,pshowtext=1;
            break;
       case DOWN: if (++curline>lines) curline--;
            if (curline>=topline+HIGHT) topline++, pshowtext=1;
            break;
       case BACK: if (x<=strlen(buf+line[curline])) {
                     if (--x<0) {
                        if (--curline<0) {curline=0;x=0;break;}
                        x=strlen(buf+line[curline]);
                        pshowtext=1;
                        }
                     if (x<linex) linex--,pshowtext=1;
                     delchar();
                     break;
                     }
       case LEFT: if (--x<0) x=0;
                  if (x<linex) linex--,pshowtext=1;
                  break;
       case RIGHT: if (++x-linex>=WIDTH)
                     ++linex, pshowtext=1;
                     break;
       case CTRLHOME: curline=topline;
       case HOME: x=0;
                  if (linex>0) linex=0,pshowtext=1;
                  break;
       case CTRLEND: if ((curline=topline+HIGHT-1)>lines) curline=lines;
       case END: linex=0;
                 x=strlen(buf+line[curline]);
                 if (x>=WIDTH) linex=x-WIDTH+1,pshowtext=1;
                 break;
       case PGUP: curline-=(HIGHT-1);
                  topline-=(HIGHT-1);
                  if (topline<0) curline=topline=0;
                  pshowtext=1;
                  break;
       case CTRLPGDOWN: topline=curline=lines;
       case PGDOWN: curline+=(HIGHT-1);
                    topline+=(HIGHT-1);
                    if (curline>lines) curline=lines;
                    if (topline>=lines)
                      topline=curline-HIGHT+1;
                    if (topline<0) topline=0;
                    pshowtext=1;
                    break;
       case CTRLPGUP: curline=topline=x=linex=0;
            pshowtext=1;
            break;
       case ENTER: inschar(0);
            break;
       case DEL: delchar();
            break;
       case INS: insert=1-insert;
            break;
       case F2: savefile(agv[1]);
            break;
       case ESC:goto esc;
       }
     if (key>=32 && key<255) {
       if (!insert) delchar();
       inschar(key);
       }
     showstatbar();
     if (pshowtext) showtext();
     else if (pshowline) showline();
     gotoxy(x-linex+1,curline-topline+1);
    }
esc:
 _setcursortype(_NORMALCURSOR);
 textbackground(STATBACK);
 textcolor(STATCOLOR);
 gotoxy(1,HIGHT);
 cprintf("Do you want save your file? (Y/N)");
 key=getch();
 if (key!='n' && key!='N') savefile(agv[1]);
 textbackground(BLACK);
 textcolor(WHITE);
 clrscr();
 copyright();
 return 0;
}
